1. Usage
====

1.1. Required
----

2 files (jsmind.css and jsmind.js) are required

    <link type="text/css" rel="stylesheet" href="style/jsmind.css" />
    <script type="text/javascript" src="js/jsmind.js"></script>

a div element should be in your HTML as container

    <div id="jsmind_container"></div>

1.2. Empty mindmap
----

It is very easy to show a mindmap:

    <script type="text/javascript">
        var options = {
            container:'jsmind_container',
            editable:true,
            theme:'orange'
        };
        var jm = jsMind.show(options);
    </script>

The example above show how to display an empty mindmap. actually, it is not empty, it includes a root node as default.

jsMind show a map in read-only mode as default, you can enable editable mode with setting the value of editable property to true.

The container option is the only required, the value should be the id of the container.

1.3. Simple mindmap
----

You can display an existing mindmap:

    <script type="text/javascript">
        var mind = {
            "meta":{
                "name":"example",
                "author":"hizzgdev@163.com",
                "version":"0.2"
            },
            "format":"node_array",
            "data":[
                {"id":"root", "isroot":true, "topic":"jsMind"},

                {"id":"easy", "parentid":"root", "topic":"Easy"},
                {"id":"easy1", "parentid":"easy", "topic":"Easy to show"},
                {"id":"easy2", "parentid":"easy", "topic":"Easy to edit"},
                {"id":"easy3", "parentid":"easy", "topic":"Easy to store"},
                {"id":"easy4", "parentid":"easy", "topic":"Easy to embed"},

                {"id":"open", "parentid":"root", "topic":"Open Source"},
                {"id":"open1", "parentid":"open", "topic":"on GitHub"},
                {"id":"open2", "parentid":"open", "topic":"BSD License"},

                {"id":"powerful", "parentid":"root", "topic":"Powerful"},
                {"id":"powerful1", "parentid":"powerful", "topic":"Base on Javascript"},
                {"id":"powerful2", "parentid":"powerful", "topic":"Base on HTML5"},
                {"id":"powerful3", "parentid":"powerful", "topic":"Depends on you"},
            ]
        };
        var options = {
            container:'jsmind_container',
            theme:'greensea',
            editable:true
        };
        var jm = jsMind.show(options,mind);
    </script>

The difference is only the arguments of jsMind.show().

It is very easy, is not it?

1.4. Data format
----

3 data formats are supported:

### (A) node tree
This is the default data format:

    {
        "meta":{
            "name":"jsMind remote",
            "author":"hizzgdev@163.com",
            "version":"0.2"
        },
        "format":"node_tree",
        "data":{"id":"root","topic":"jsMind","children":[
            {"id":"easy","topic":"Easy","direction":"left","children":[
                {"id":"easy1","topic":"Easy to show"},
                {"id":"easy2","topic":"Easy to edit"},
                {"id":"easy3","topic":"Easy to store"},
                {"id":"easy4","topic":"Easy to embed"}
            ]},
            {"id":"open","topic":"Open Source","direction":"right","children":[
                {"id":"open1","topic":"on GitHub"},
                {"id":"open2","topic":"BSD License"}
            ]},
            {"id":"powerful","topic":"Powerful","direction":"right","children":[
                {"id":"powerful1","topic":"Base on Javascript"},
                {"id":"powerful2","topic":"Base on HTML5"},
                {"id":"powerful3","topic":"Depends on you"}
            ]},
            {"id":"other","topic":"test node","direction":"left","children":[
                {"id":"other1","topic":"I'm from local variable"},
                {"id":"other2","topic":"I can do everything"}
            ]}
        ]}
    }


### (B) node array
This data format help you to operate the data from database)

    {
        "meta":{
            "name":"example",
            "author":"hizzgdev@163.com",
            "version":"0.2"
        },
        "format":"node_array",
        "data":[
            {"id":"root", "isroot":true, "topic":"jsMind"},

            {"id":"easy", "parentid":"root", "topic":"Easy", "direction":"left"},
            {"id":"easy1", "parentid":"easy", "topic":"Easy to show"},
            {"id":"easy2", "parentid":"easy", "topic":"Easy to edit"},
            {"id":"easy3", "parentid":"easy", "topic":"Easy to store"},
            {"id":"easy4", "parentid":"easy", "topic":"Easy to embed"},

            {"id":"open", "parentid":"root", "topic":"Open Source", "direction":"right"},
            {"id":"open1", "parentid":"open", "topic":"on GitHub"},
            {"id":"open2", "parentid":"open", "topic":"BSD License"},

            {"id":"powerful", "parentid":"root", "topic":"Powerful", "direction":"right"},
            {"id":"powerful1", "parentid":"powerful", "topic":"Base on Javascript"},
            {"id":"powerful2", "parentid":"powerful", "topic":"Base on HTML5"},
            {"id":"powerful3", "parentid":"powerful", "topic":"Depends on you"},
        ]
    }


### (C) freemind
This is example of freemind

    {
        "meta":{
            "name":"example",
            "author":"hizzgdev@163.com",
            "version":"0.2"
        },
        "format":"freemind",
        "data":"<map version=\"1.0.1\"> <node ID=\"root\" TEXT=\"jsMind\" > <node ID=\"easy\" POSITION=\"left\" TEXT=\"Easy\" > <node ID=\"easy1\" TEXT=\"Easy to show\" /> <node ID=\"easy2\" TEXT=\"Easy to edit\" /> <node ID=\"easy3\" TEXT=\"Easy to store\" /> <node ID=\"easy4\" TEXT=\"Easy to embed\" /> </node> <node ID=\"open\" POSITION=\"right\" TEXT=\"Open Source\" > <node ID=\"open1\" TEXT=\"on GitHub\" /> <node ID=\"open2\" TEXT=\"BSD License\" /> </node> <node ID=\"powerful\" POSITION=\"right\" TEXT=\"Powerful\" > <node ID=\"powerful1\" TEXT=\"Base on Javascript\" /> <node ID=\"powerful2\" TEXT=\"Base on HTML5\" /> <node ID=\"powerful3\" TEXT=\"Depends on you\" /> </node> <node ID=\"other\" POSITION=\"left\" TEXT=\"test node\" > <node ID=\"other1\" TEXT=\"I'm from local variable\" /> <node ID=\"other2\" TEXT=\"I can do everything\" /> </node> </node> </map>"
    }

1.5. Options
----

As what you see above, you can customize jsMind with some options like this: 

    var options = {
        container:'jsmind_container',
        theme:'greensea',
        editable:true
    };

Actually, some other options are also supported, these are all options below, you may rewrite any of it in your code.

    var DEFAULT_OPTIONS = {
        container : '',         // id of the container where the mindmap loaded on
        editable : false,       // allow user to edit the mindmap or not
        theme : null,           // see [1.6. Themes] for more information
        mode :'full',           // show topic on right side only, or both left and right
        support_html : true,    // support html on node topic

        view:{
            hmargin:100,        // top and bottom padding of container, in pixels
            vmargin:50          // left and right padding of container, in pixels
        },
        layout:{
            hspace:30,          // horizontal space between nodes, in pixels
            vspace:20,          // vertical space between nodes, in pixels
            pspace:13           // width and height of collaps/expand pointer, in pixels
        },
        shortcut:{
            enable:true,        // enable shortcut
            handles:{},         // add your custome handles here, some build-in handles are supported
            mapping:{           // handle mapping.
                addchild   : 45,    // <Insert>
                addbrother : 13,    // <Enter>
                editnode   : 113,   // <F2>
                delnode    : 46,    // <Delete>
                toggle     : 32,    // <Space>
                left       : 37,    // <Left>
                up         : 38,    // <Up>
                right      : 39,    // <Right>
                down       : 40,    // <Down>
            }
        },
    };

1.6. Themes
----

15 themes was supported in jsmind, you can use them as you like:

+ primary
+ warning
+ danger
+ success
+ info
+ greensea
+ nephrite
+ belizehole
+ wisteria
+ asphalt
+ orange
+ pumpkin
+ pomegranate
+ clouds
+ asbestos

visit [Demo-features](http://hizzgdev.github.io/jsmind/example/2_features.html) for preview.

And, you can add your theme in jsmind.css.

It's greensea theme defined in jsmind.css as example:

    /* greensea theme */
    jmnodes.greensea jmnode{background-color:#1abc9c;color:#fff;}
    jmnodes.greensea jmnode:hover{background-color:#16a085;}
    jmnodes.greensea jmnode.selected{background-color:#11f;color:#fff;}
    jmnodes.greensea jmnode.root{}
    jmnodes.greensea jmexpander{}
    jmnodes.greensea jmexpander:hover{}

